@version 2.2
@warnings 0
@script channel

sins;
ranges;
fps;
start;
clist;
behavior;

create: channel
{
    sins = nil;
	ranges = nil;
	start = nil;
	behavior = 1;
	setdesc("Coccals_MultiSin");
}

destroy
{
    // take care of final clean-up activities here
	sins = nil;
	ranges = nil;
	start = nil;
}

process: ca, frame, time
{
    // 'ca' is the Channel Filter Object Agent

    // it exports one read-only data member:
    //       name      the name of the channel as
    //                 it is displayed to the user

    // it provides two methods:
    //       get       returns the value of the
    //                 channel (as a floating-point
    //                 number) for an indicated time
    //                 index
    //       set       sets the channel's value to
    //                 the provided floating-point
    //                 value for the current time
    //                 index (indicated by the 'time'
    //                 argument to process()).
	
	if (sins.size() > 0)
	{
	if (frame <= ranges[1][1])
	{
		if (behavior == 1)
			val = sin(ranges[1][1] * sins[1] / (2 * PI)  + start[1] * PI / 2);
		else
		{
			y = sin(ranges[1][1] * sins[1] / (2 * PI)  + start[1] * PI / 2);
			if (ranges[1][1] == 0)
				val = (frame) * y / 0.001;
			else
				val = (frame) * y / (ranges[1][1]);
		}

		ca.set(val);
		return;
	}

	ind = sins.size();

	if (frame >= ranges[ind][2])
	{
		val = sin(ranges[ind][2] * sins[ind] / (2 * PI)  + start[ind] * PI / 2);
		ca.set(val);
		return;
	}

	}
	
	for (i = 1; i <= sins.size(); i++)
		if (frame > ranges[i][1] && frame < ranges[i][2])	
		{
			val = sin(frame * sins[i] / (2 * PI)  + start[i] * PI / 2);
			ca.set(val);
			return;
		}

	for (i = 1; i < sins.size(); i++)
	{
		if (frame >= ranges[i][2] && frame <= ranges[i + 1][1])	
		{
		
		if (behavior == 1)
		val = sin(ranges[i][2] * sins[i] / (2 * PI)  + start[i] * PI / 2);
		else
		{
			y1 = sin(ranges[i][2] * sins[i] / (2 * PI)  + start[i] * PI / 2);
			y2 = sin(ranges[i + 1][1] * sins[i + 1] / (2 * PI)  + start[i + 1] * PI / 2);
			val = ((frame - ranges[i][2]) * (y2 - y1) + y1 * (ranges[i+1][1] - ranges[i][2])) / (ranges[i+1][1] - ranges[i][2]);
		}

		ca.set(val);
		return;
		}
	}
}

load: what,io
{
    if(what == OBJECTMODE)   // processing an ASCII scene file
    {
	size = integer(io.readNumber());
	for (i = 1; i<= size; i++)
	{
		sins[i] = integer(io.readNumber());
		ranges[i][1] = integer(io.readNumber());
		ranges[i][2] = integer(io.readNumber());
		start[i] = io.readNumber();
	}
	behavior = integer(io.readNumber());
    }

	if (what == SCENEMODE)
	{
		size = integer(io.read());
		for (i = 1; i <= size; i++)
		{
			sins[i] = integer(io.read());
			ranges[i][1] = integer(io.read());
			ranges[i][2] = integer(io.read());
			start[i] =  number(io.read());
		}
		behavior = integer(io.read());
	}

	fps = Scene().fps;
}

save: what,io
{
    if(what == OBJECTMODE)
    {
	io.writeNumber(sins.size());
	for (i = 1; i <= sins.size(); i++)
	{
		io.writeNumber(sins[i]);
		io.writeNumber(ranges[i][1]);
		io.writeNumber(ranges[i][2]);
		io.writeNumber(start[i]);
	}
	io.writeNumber(behavior);
    }

	if (what == SCENEMODE)
	{
		io.writeln(sins.size());
		for (i = 1; i <= sins.size(); i++)
		{
			io.writeln(sins[i]);
			io.writeln(ranges[i][1]);
			io.writeln(ranges[i][2]);
			io.writeln(start[i]);
		}
		io.writeNumber(behavior);
	}
	
}

options
{
	fps = Scene().fps;
    reqbegin("Multi_Sin");

    clist = ctllistbox("Frequency - Range: Initial Frame--> Final Frame - Initial Value",320,300,"count","item");
	c2 = ctlbutton("Add", 60, "AddSin");
	ctlposition(c2, 50, 310);
	c3 = ctlbutton("Edit",60, "EditSin");
	ctlposition(c3, 200, 310);
	c4 = ctlchoice("Behavior in between:",behavior, @"Costant","Linear"@);
	ctlposition(c4, 59, 340);
	
	return if !reqpost();

	behavior = c4.value;

    reqend();

	if (sins.size() > 0)
		setdesc("Coccals_MultiSin - on "+sins.size()+" Sin");
	else
		setdesc("Coccals_MultiSin");
		
}

count
{
	return (sins.size());
}

item: index
{	
	return (string(sins[index]) +" every "+fps+" frames - Range:"+string(ranges[index][1])+" --> "+string(ranges[index][2])+"- Initial value:"+start[index]);
} 

AddSin
{
	reqbegin("Multi_Sin");

	c1 = ctlnumber("Top value every second:",1.0);
	c2 = ctlinteger("Initial Frame",1);
	c3 = ctlinteger("Final Frame",60);
	c4 = ctlpercent("Start with value:",0.0);
    
    return if !reqpost();
	
	Freq = c1.value;
	Init = c2.value;
	End = c3.value;
	st = c4.value;

    reqend();

	if (sins == nil)
		ind = 1;
	else
		ind = sins.size() + 1;

	if (End <= Init)
	{
		info("Error: The Ending frame is smaller than the Initial frame.");
		return;
	}

	for (i = 1; i <= sins.size(); i++)
		if ((Init >= ranges[i][1] && Init <= ranges[i][2]) || (End >= ranges[i][1] && End <= ranges[i][2]))
		{
			info("Error: Founded intersection between pre-existing range.");
			return;
		}
	
	if (st < 0.0)
		st = 0.0;

	if (st > 1.0)
		st = 1.0;
		
	sins[ind] = Freq;
	ranges[ind][1] = Init;
	ranges[ind][2] = End;
	start[ind] = st;

	Sort();

	requpdate();
}

EditSin
{
	if (sins.size() != 0)
	{
	sel = clist.value;
	if (sel)
	{

	s = sel[1];

	reqbegin("Multi_Sin");

	c1 = ctlnumber("Frequency every second:",sins[s]);
	c2 = ctlinteger("Initial Frame",ranges[s][1]);
	c3 = ctlinteger("Final Frame",ranges[s][2]);
	c4 = ctlpercent("Start with value:",start[s]);
    
    return if !reqpost();
	
	Freq = c1.value;
	Init = c2.value;
	End = c3.value;
	st = c4.value;

    reqend();

	if (End <= Init)
	{
		info("Error: The Ending frame is smaller than the Initial frame.");
		return;
	}

	for (i = 1; i <= sins.size(); i++)
	{
		if (i != s)
		if ((Init >= ranges[i][1] && Init <= ranges[i][2]) || (End >= ranges[i][1] && End <= ranges[i][2]))
		{
			info("Error: Founded intersection between pre-existing range.");
			return;
		}
	}
	
	if (st < 0.0)
		st = 0.0;

	if (st > 1.0)
		st = 1.0;
		
	sins[s] = Freq;
	ranges[s][1] = Init;
	ranges[s][2] = End;
	start[s] = st;

	Sort();

	requpdate();
	}
	}
}

Sort
{
	if (sins.size() > 1)
	for (i = 1; i <= sins.size(); i++)
	{
		for (j = sins.size(); j > i; j--)
		{
			if (ranges[j - 1][1] > ranges[j][1])
			{	
				tempsin = sins[j - 1];
				temprange1 = ranges[j - 1][1];
				temprange2 = ranges[j - 1][2];
				tempstart = start[j - 1];

				sins[j - 1] = sins[j];
				ranges[j - 1][1] = ranges[j][1];
				ranges[j - 1][2] = ranges[j][2];
				start[j - 1] = start[j];

				sins[j] = tempsin;
				ranges[j][1] = temprange1;
				ranges[j][2] = temprange2;
				start[j] = tempstart;
			}
		}
		
	}
}